routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\SubCategoryController;


Route::resource('/', CategoryController::class);

Route::resource('category', CategoryController::class);
Route::resource('sub_category', SubCategoryController::class);
Route::resource('product', ProductController::class);

Route::get('category/products/{category_id}', [ProductController::class , 'category_products']);
Route::get('category/sub_categories/{category_id}', [SubCategoryController::class , 'category_sub_categories']);
Route::get('sub_category/products/{sub_category_id}', [ProductController::class , 'sub_category_products']);

app/Models/Product.php
<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Product extends Model
{
	use SoftDeletes;
	protected $table = 'products';

	protected $casts = [
		'sub_category_id' => 'int',
		'is_active' => 'bool',
		'measurement_unit_id' => 'int'
	];

	protected $fillable = [
		'sub_category_id',
		'name',
		'code',
		'description',
		'is_active',
		'tags',
		'measurement_unit_id',
		'hsn_code'
	];

	public function sub_category()
	{
		return $this->belongsTo(SubCategory::class);
	}
    public function measurement_unit()
	{
		return $this->belongsTo(MeasurementUnit::class);
	}
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\MeasurementUnit;
use App\Models\Product;
use App\Models\SubCategory;
use Illuminate\Http\Request;

class ProductController extends Controller
{

    public function index()
    {
        $products = Product::with(['sub_category.category', 'measurement_unit.measurement_type'])->latest()->paginate(5);

        return view('product.index', compact('products'))
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }

    public function category_products(Request $request)
    {
        $category_id = $request->route('category_id');
        $products = Product::with(['sub_category.category', 'measurement_unit.measurement_type'])
            ->whereHas('sub_category', function ($q) use ($category_id) {
                $q->where('category_id', '=', $category_id);
            })->latest()->paginate(5);

        return view('product.index', compact('products'))
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }

    public function sub_category_products(Request $request)
    {
        $sub_category_id = $request->route('sub_category_id');
        $products = Product::with(['sub_category.category', 'measurement_unit.measurement_type'])
            ->where('sub_category_id', '=', $sub_category_id)->latest()->paginate(5);

        return view('product.index', compact('products'))
            ->with('i', (request()->input('page', 1) - 1) * 5);
    }


    public function create()
    {
        $result['sub_categories'] = SubCategory::where('is_active', '=', true)->get();
        $result['measurement_units'] = MeasurementUnit::with(['measurement_type'])->get();
        return view('product.create', compact('result'));
    }


    public function store(Request $request)
    {
        $request->validate([
            'name' => [
                'required',
                'unique:products,name'
            ],
            'code' => [
                'required',
                'unique:products,code'
            ],
            'sub_category_id' => 'required',
            'measurement_unit_id' => 'required'
        ]);

        Product::create($request->all());

        return redirect()->route('product.index')
            ->with('success', 'Product created successfully.');
    }

    public function show(Product $product)
    {
        return view('product.show', compact('product'));
    }


    public function edit(Product $product)
    {
        $result['sub_categories'] = SubCategory::where('is_active', '=', true)->get();
        $result['measurement_units'] = MeasurementUnit::with(['measurement_type'])->get();
        $result['product'] = $product;
        return view('product.edit', compact('result'));
    }

    public function update(Request $request, Product $product)
    {
        $request->validate([
            'name' => [
                'required',
                function ($a, $v, $f) use ($product) {
                    if (Product::where('id', '!=', $product->id)->where('name', '=', $v)->exists()) {
                        $f("Name Aleady taken");
                    }
                }
            ],
            'code' => [
                'required',
                function ($a, $v, $f) use ($product) {
                    if (Product::where('id', '!=', $product->id)->where('code', '=', $v)->exists()) {
                        $f("Code Aleady taken");
                    }
                }
            ],
            'sub_category_id' => 'required',
            'measurement_unit_id' => 'required'
        ]);
        $product->update($request->all());

        return redirect()->route('product.index')
            ->with('success', 'Product updated successfully');
    }

    public function destroy(Product $product)
    {
        $product->delete();

        return redirect()->route('product.index')
            ->with('success', 'Product deleted successfully');
    }
}

resources/views/product/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Add New Product</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('product.index') }}" title="Go back"> <i class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            <strong>Whoops!</strong> There were some problems with your input.<br><br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    <form action="{{ route('product.store') }}" method="POST" >
        @csrf

        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Sub Category:</strong>
                    <select class="form-control" name="sub_category_id">
                        @foreach ($result['sub_categories'] as $i => $sub_category)
                        <option value="{{ $sub_category->id }}">{{ $sub_category->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Name:</strong>
                    <input type="text" name="name" class="form-control" placeholder="Name">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Code:</strong>
                    <input type="text" name="code" class="form-control" placeholder="code">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Measurement Unit:</strong>
                    <select class="form-control" name="measurement_unit_id">
                        @foreach ($result['measurement_units'] as $i => $measurement_unit)
                        <option value="{{ $measurement_unit->id }}">{{ $measurement_unit->name.' | '.$measurement_unit->measurement_type->name }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Description:</strong>
                    <textarea type="text" name="description" class="form-control" placeholder="description"></textarea>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Tags:</strong>
                    <textarea type="text" name="tags" class="form-control" placeholder="tags"></textarea>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Hsn Code:</strong>
                    <input type="text" name="hsn_code" class="form-control" placeholder="Hsn Code">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </div>

    </form>
@endsection

resources/views/product/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Edit Product</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('sub_category.index') }}" title="Go back"> <i
                        class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            <strong>Whoops!</strong> There were some problems with your input.<br><br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('product.update', $result['product']->id) }}" method="POST">
        @csrf
        @method('PUT')

        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Name:</strong>
                    <input type="text" name="name" value="{{ $result['product']->name }}" class="form-control" placeholder="Name">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Sub Category:</strong>
                    <select class="form-control" name="sub_category_id">
                        @foreach ($result['sub_categories'] as $i => $sub_category)
                        <option value="{{ $sub_category->id }}"
                        @if ($result['product']->sub_category_id == $sub_category->id)
                            selected="selected"
                        @endif
                        >{{$sub_category->name}}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Measurement Unit:</strong>
                    <select class="form-control" name="measurement_unit_id">
                        @foreach ($result['measurement_units'] as $i => $measurement_unit)
                        <option value="{{ $measurement_unit->id }}"
                        @if ($result['product']->measurement_unit_id == $measurement_unit->id)
                            selected="selected"
                        @endif
                        >{{$measurement_unit->name .' | '.$measurement_unit->measurement_type->name}}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Code:</strong>
                    <input type="text" name="code" class="form-control" placeholder="{{ $result['product']->code }}"
                        value="{{ $result['product']->code }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Description:</strong>
                    <input type="text" name="description" class="form-control" placeholder="{{ $result['product']->description }}"
                        value="{{ $result['product']->description }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Tags:</strong>
                    <input type="text" name="tags" class="form-control" placeholder="{{ $result['product']->tags }}"
                        value="{{ $result['product']->tags }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>HSN Code:</strong>
                    <input type="text" name="hsn_code" class="form-control" placeholder="{{ $result['product']->hsn_code }}"
                        value="{{ $result['product']->hsn_code }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </div>

    </form>
@endsection

resources/views/product/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Products</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-success" href="{{ route('product.create') }}" title="Create a Product"> <i class="fas fa-plus-circle"></i>
                    </a>
            </div>
        </div>
    </div>

    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @endif

    <table class="table table-bordered table-responsive-lg">
        <tr>
            <th>No</th>
            <th>Name</th>
            <th>Category</th>
            <th>Type</th>
            <th>Sub Category</th>
            <th>Code</th>
            <th>Measurement Unit</th>
            <th>Is Active</th>
            <th>Description</th>
            <th>Tags</th>
            <th>HSN Code</th>
            <th>Created At</th>
            <th width="280px">Action</th>
        </tr>
        @foreach ($products as $product)
            <tr>
                <td>{{ ++$i }}</td>
                <td>{{ $product->name }}</td>
                <td>{{ $product->sub_category->category->name }}</td>
                <td>{{ $product->sub_category->category->type }}</td>
                <td>{{ $product->sub_category->name }}</td>
                <td>{{ $product->code }}</td>
                <td>{{ $product->measurement_unit->name.' | '.$product->measurement_unit->measurement_type->name }}</td>
                <td>{{ $product->is_active }}</td>
                <td>{{ $product->description??'' }}</td>
                <td>{{ $product->tags??'' }}</td>
                <td>{{ $product->hsn_code??'' }}</td>
                <td>{{ $product->created_at->format('jS M Y') }}</td>
                <td>
                    <form action="{{ route('product.destroy', $product->id) }}" method="POST">

                        <a href="{{ route('product.show', $product->id) }}" title="show">
                            <i class="fas fa-eye text-success  fa-lg"></i>
                        </a>

                        <a href="{{ route('product.edit', $product->id) }}">
                            <i class="fas fa-edit  fa-lg"></i>

                        </a>

                        @csrf
                        @method('DELETE')

                        <button type="submit" title="delete" style="border: none; background-color:transparent;">
                            <i class="fas fa-trash fa-lg text-danger"></i>

                        </button>
                    </form>
                </td>
            </tr>
        @endforeach
    </table>

    {!! $products->links() !!}

@endsection

resources/views/product/show.blade.php
@extends('layouts.app')


@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2> {{ $product->name }}</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-primary" href="{{ route('product.index') }}" title="Go back"> <i
                        class="fas fa-backward "></i> </a>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Name:</strong>
                {{ $product->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Sub Category:</strong>
                {{ $product->sub_category->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Category:</strong>
                {{ $product->sub_category->category->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Type:</strong>
                {{ $product->sub_category->category->type }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Measurement Unit:</strong>
                {{ $product->measurement_unit->name.' | '.$product->measurement_unit->measurement_type->name }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Code:</strong>
                {{ $product->code }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Description:</strong>
                {{ $product->description??'' }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Tags:</strong>
                {{ $product->tags??'' }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>HSN Code:</strong>
                {{ $product->hsn_code??'' }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Created At:</strong>
                {{ $product->created_at->format('jS M Y') }}
            </div>
        </div>
    </div>
@endsection